#include "math.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include "lib.h"



void check_timer(gpointer gp){
	int i;
	if ( gtk_toggle_button_get_active(lookup_widget(GTK_WIDGET(window1), "freeze"))==FALSE){
		GtkWidget *drawarea = lookup_widget(GTK_WIDGET(window1), "drawingarea"); 
//		g_print("beta%f\n",beta);
		if (gtk_toggle_button_get_active(lookup_widget(GTK_WIDGET(window1), "radio_cluster"))==TRUE){
			update_spin();
			update_link();
			find_cluster1();
		}else{
			for (i = 0; i<L*L;i++){
		                int pos = get_position();
               			int x = pos/L;
              			int y = pos%L;
               			double h0 = 0;//b;
      			        h0 += gitter[get_neighbour1(pos)];
           			h0 += gitter[get_neighbour2(pos)];
               			h0 += gitter[get_neighbour3(pos)];
                		h0 += gitter[get_neighbour4(pos)];
                		double p = exp(beta*h0)/(exp(-1.*beta*h0)+exp(beta*h0));
                		double z = (1.*rand())/(1.*RAND_MAX);
                		if (z<p){
                     		   gitter[pos]=1;
                		}else{
                       		   gitter[pos]=-1;
              			}
       			 }
		}
		gtk_widget_queue_draw(drawarea);
	}
}

//rechten Nachbar finden
int get_neighbour1(int pos){
	if (pos%L==0){
		return (pos+L-1);
	}else{
		return (pos-1);
	}
}

//linken Nachbar finden
int get_neighbour2(int pos){
	if ((pos+1)%L==0){
		return (pos-L+1);
	}else{
		return (pos+1);
	}
}

//unteren Nachbar finden
int get_neighbour3(int pos){
	if (pos<L){
		return pos+L*(L-1);
	}else{
		return pos-L;
	}
}

//oberen Nachbar finden
int get_neighbour4(int pos){
	if (pos>=L*(L-1)){
		return pos%L;
	}else{
		return pos+L;
	}
	
}

int get_link_con1(int l){
	return l%N;
}

int get_link_con2(int l){
	if (l/N==0) return get_neighbour1(l%N);
	return get_neighbour3(l%N);
}

double p(){
	return 1.-exp(-2.*beta);
}


void update_link(){
	int i;
	for (i = 0; i<2*N;i++){
	 if(gitter[get_link_con1(i)]==gitter[get_link_con2(i)]){
                double z = (1.*rand())/(1.*RAND_MAX);
                linc[i]=FALSE;
                if(z<p()) linc[i]=TRUE;
         }else{
                linc[i]=FALSE;
         }
	}
}


void find_cluster(int i){
	if(linc[i] && (clusternr[get_neighbour1(i)]==0)){
		clusternr[get_neighbour1(i)]=clusteranzahl;
		find_cluster(get_neighbour1(i));
	}
	if(linc[i+N] && (clusternr[get_neighbour3(i)]==0)){
		clusternr[get_neighbour3(i)]=clusteranzahl;
		find_cluster(get_neighbour3(i));
	}
	if(linc[get_neighbour2(i)] && (clusternr[get_neighbour2(i)]==0)){
		clusternr[get_neighbour2(i)]=clusteranzahl;
		find_cluster(get_neighbour2(i));
	}
	if(linc[get_neighbour4(i)+N] && (clusternr[get_neighbour4(i)]==0)){
		clusternr[get_neighbour4(i)]=clusteranzahl;
		find_cluster(get_neighbour4(i));
	}
}

void find_cluster1(){
	int i;
	clusteranzahl=0;
	for(i=0;i<N;i++){
		clusternr[i]=0;
	}
	for(i=0;i<N;i++){
		if(clusternr[i]==0){
			clusteranzahl++;	
			clusternr[i]=clusteranzahl;
			find_cluster(i);
		}
	}
}

void update_spin(){
	int i,j;
	for(i=1;i<=clusteranzahl;i++){
		double z = (1.*rand())/(1.*RAND_MAX);
		if(z>0.5){
			for (j=0;j<N;j++){
				if(clusternr[j]==i){
					gitter[j]*=-1;
				}
			}
		}
	}
	
}

void init_gitter_hot(){
	int i;
	for (i = 0; i<N;i++){
		double z = (1.*rand())/(1.*RAND_MAX);
		gitter[i]=-1;
		if (z<0.5){
			gitter[i]=1;
		}
	}
	update_link();
}

void init_gitter_cold(){
	int i;
	for ( i = 0; i<N;i++){
		gitter[i] =1;
	}
	update_link();
}
	

int get_position(){
	return (int)((1.*rand())/(1.*RAND_MAX)*N);
}

double sk(){
	int i;
	double ret=0;
	for (i = 0; i<N;i++){
		ret+=gitter[i];
	}
	return ret/(double)(N);
}


void iterate(){
/*	for (int i = 0; i<L*L;i++){
		int pos = get_position();
		int x = pos/L;
		int y = pos%L;
		double h0 = b;
		h0 += gitter[get_neighbour1(pos)];
		h0 += gitter[get_neighbour2(pos)];
		h0 += gitter[get_neighbour3(pos)];
		h0 += gitter[get_neighbour4(pos)];
		double p = exp(beta*h0)/(exp(-1.*beta*h0)+exp(beta*h0));
		double z = (1.*rand())/(1.*RAND_MAX);
		if (z<p){
			gitter[pos]=1;
		}else{
			gitter[pos]=-1;
		}
	}
*/
	g_print("iterate\n");
	update_link();
	find_cluster1();
	update_spin();
}



/*
main(int argc, char *argv[])
{
	// Lese Daten ein
 	if (argc<3){
        	cout << "Bitte mindestens zwei Parameter (beta, b) uebergeben!" <<endl;
        	return -1;
    	}
    	beta 	=atof(argv[1]);
    	b 	=atof(argv[2]);
	
	// Initialisiere Zufallsgenerator
	srand ( time(NULL) );
		
	// Initialisiere Gitter
	init_gitter_hot();


	for (beta=0.45;beta<=0.46;beta=beta+0.001){
		// Voriterationen
		cerr << beta << endl;
		for (int i = 0; i< 10;i++){
			iterate();
		}
		// Berechne Mittelwerte und Quadrate der Magnetisierung
		double mean_sk		= 0;
		double mean_sk_square	= 0;
		int    anzmittel	= 100;
		int    anzzwischeniter	= 1;	
		for (int j = 0; j<anzmittel;j++){
			// Zwischeniterationen
			for (int u = 0; u<anzzwischeniter;u++){
				iterate();
			}
			double tempsk=sk();
			mean_sk		+= abs(tempsk);
			mean_sk_square	+= tempsk*tempsk;
		}
		mean_sk	 	= mean_sk        /(1.*anzmittel);
		mean_sk_square 	= mean_sk_square /(1.*anzmittel);
		double sigma = sqrt(mean_sk_square-mean_sk*mean_sk)
				/sqrt((double)anzmittel);
		// Ausgabe
		cout << beta << "\t"<< mean_sk << "\t"<< sigma << endl;
	}
	
	return 0;
}
*/	
	

